﻿// ------------------------------
// setup global variables
var refreshRate = 1; //number of hours between RSS reloads
var isLoaded = false;
var feedItems; //array of RSS feed items
var feedTimer; //timeout object for reading RSS
var item; //currently selected item (for flyout)
var scrollTimer; //interval object for display scroller
var scrollOuterEl; //outer scroll element
var scrollEl; //inner scroll element
var sliderCurrent; //left position (in pixels) of the scrollEl within scrollOuterEl
var flyoutDocument; //document object of the flyout window
var imageURL;
var photoBy;
var pubDate;
var imageDescription;


// called when the gadget loads
function pageLoad() {
    window.detachEvent("onload", pageLoad);
	window.attachEvent("onunload", pageUnload);
	
	var el, gadgetEl;

	feedItems = []; //setup an empty array for the RSS feed items

	//setup the flyout stuff	
	System.Gadget.Flyout.onShow = onFlyoutShow;
	System.Gadget.Flyout.onHide = onFlyoutHide;
	System.Gadget.Flyout.file = "flyout.html";

	//setup the docked stuff
	//System.Gadget.onDock = dockStateChanged;
	//System.Gadget.onUndock = dockStateChanged;

	//setup the settings stuff
	//System.Gadget.settingsUI = "settings.html";
	//System.Gadget.onSettingsClosed = settingsClosed;

    

	//settingsRead(); //get the feed refresh rate
	//dockStateChanged(); //setup the gadget in docked or undocked mode

	getFeed(); //start loading the RSS feed
	
	//clearHover(); //setup the scroll timer

	el = gadgetEl = null;
}

// called when the gadget unloads
function pageUnload() {
    window.detachEvent("onunload", pageUnload);

	//shut down timers (if running)
	if (feedTimer) {
		clearTimeout(feedTimer);
		feedTimer=null;
	}

	//unhook mouse over/out events
	//scrollOuterEl.detachEvent("onmouseover", setHover);
	//scrollOuterEl.detachEvent("onmouseout", clearHover);

	flyoutDocument = feedItems = item = scrollEl = scrollOuterEl = null;
}

// called when a flyout is shown
function onFlyoutShow() {

	flyoutDocument = System.Gadget.Flyout.document; //get the flyout document object

	//fill the flyout elements with the selected news item
	main = flyoutDocument.getElementById("main");
	desc = flyoutDocument.getElementById("description");
	postedby = flyoutDocument.getElementById("postedby");
	postedDate = flyoutDocument.getElementById("postedDate");
	comments = flyoutDocument.getElementById("comments");
	img = flyoutDocument.getElementById("plantimage");
	sitelink = flyoutDocument.getElementById("sitelink");
	sitelink2 = flyoutDocument.getElementById("sitelink2");
	desc.innerHTML = imageDescription;
	postedby.innerHTML = photoBy;
	postedDate.innerHTML = pubDate;
	sitelink.href = 'http://www.iheartgardening.com/Encyclopedia/Identify.aspx';
	sitelink2.href = 'http://www.iheartgardening.com/Encyclopedia/Identify.aspx';
	img.src = 'http://www.iheartgardening.com' + imageURL.replace('/Thumbs', '');
	img.style.height = 300;
	
//	comments.innerHTML = "";	
//    for (i=0; i<feedItems.length; i++) {
//	    li = flyoutDocument.createElement("li");
//	    li.innerHTML = hesc(feedItems[i].description) + ' - ' + hesc(feedItems[i].title) + ' - ' + hesc(feedItems[i].date);
//	    comments.appendChild(li);
//	    li = null;
//    }

    mainDocument = System.Gadget.document;
    var ogadget = mainDocument.getElementById("gadget");
    var ologo = mainDocument.getElementById("logo");
    ologo.onclick = getClickFn();
    ologo.style.display = 'block';
    ogadget.style.display = 'none';
    mainDocument.body.style.backgroundColor = "#FFFFFF";
	    
	desc = main = comments = null;
}

// called when a flyout is hidden
function onFlyoutHide() {
	flyoutDocument = item = null;
	
	mainDocument = System.Gadget.document;
	mainDocument.body.style.backgroundColor = "#000000";
    var ogadget = mainDocument.getElementById("gadget");
    var ologo = mainDocument.getElementById("logo");
    ologo.style.display = 'none';
    ogadget.style.display = 'block';
	
	//clearHover();
}

// called once every hour to load a new RSS feed
function getFeed() {
	//shut down feed timer (if running)
	if (feedTimer) {
		clearTimeout(feedTimer);
		feedTimer=null;
	}
	var xdoc = new ActiveXObject("Microsoft.XMLDOM");
	xdoc.onreadystatechange = function () {
		if ( xdoc.readyState == 4 ) {
			onXmlReturnHandler(xdoc);
		}
	};
	
	xdoc.load('http://www.iheartgardening.com/encyclopedia/Identifyrss.aspx');
	
}

// called after the RSS file is loaded
function onXmlReturnHandler(xdoc) {
	var n, node, nodes, item;
	feedItems = []; //clear the old array
	try {
	    // First get the image info
	    node = xdoc.selectSingleNode("/rss/channel/image");
	    nodeChannel = xdoc.selectSingleNode("/rss/channel");
	    if (node)
	    {
	        isLoaded = true;
	        imageURL = node.selectSingleNode('url').text;
	        imageDescription = node.selectSingleNode('description').text;
	        photoBy = node.selectSingleNode('title').text;
	        
	        if (nodeChannel)
	        {
	            pubDate = nodeChannel.selectSingleNode('pubDate').text;
	        }
    	
		    nodes = xdoc.selectNodes("/rss/channel/item");
		    for (n=0; n < nodes.length; n++){
			    node = nodes[n];
			    item = {};
			    item.title = node.selectSingleNode('title').text;
			    item.date = node.selectSingleNode('pubDate').text;
			    item.link = node.selectSingleNode('link').text;
			    item.description = node.selectSingleNode('description').text;
			    //item.creator = node.selectSingleNode('dc:creator').text;
			    feedItems.push(item);
		    }
		    
		    ShowItems();
	    }
	    else
	    {
	        setTimeout(getFeed, 15000);
	    }
	    
	    
	} catch(ex) {}
	nodes = item = xdoc = null;
	//setup timer to load again
    feedTimer = setTimeout(getFeed, 1000*60*60*refreshRate); //reload again in an X hours
}

function ShowItems()
{
//    if (feedItems.length > 0) 
//    {
	    //build news feed DIV
	    gadgetEl = document.getElementById("gadget"); //get the container
	    var loading = document.getElementById("loading");
	    gadgetEl.innerHTML = "";
    	
    	img = document.createElement("img");
    	img.src = 'http://www.iheartgardening.com' + imageURL;
    	img.style.width = "130px";
    	img.onclick = getClickFn();
    	gadgetEl.appendChild(img);
    	
    	imglogo = document.createElement("img");
    	imglogo.src = "ihglogo_sm.jpg";
    	imglogo.style.position = "absolute";
    	imglogo.style.zIndex = "2";
    	imglogo.style.top = "99px";
    	imglogo.style.left = "79px";
    	imglogo.style.width = "51px";
    	imglogo.style.height = "51px";
    	gadgetEl.appendChild(imglogo);
    	
    	
    	gadgetEl.style.display = 'block';
        loading.style.display = 'none';
        document.body.style.backgroundColor = "#000000";
	
    	
   // }
}

//return a pointer to a function
function getClickFn() {
	return function() {
		if (flyoutDocument) {
			onFlyoutShow(); //flyout already visible
		} else {
			System.Gadget.Flyout.show = true; //show the flyout
		}
	};
}

//escape an HTML string
function hesc(p_str) {
    return p_str.replace(/&/g,"&amp;").replace(/</g, "&lt;").replace(/>/g,"&gt;").replace(/\"/g,"&quot;");
}
// ------------------------------
// this gets everything started after the DOM is created
window.attachEvent("onload", pageLoad);
